using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

namespace ImageSharpApp.AlgProcessor.Forms
{
    partial class FilterSpectralHighpassForm : Form
    {
        private bool userChanged = false;
        private FilterSpectralHighpassParams pars = null;

        public FilterSpectralHighpassParams Params
        {
            get
            {
                return this.pars;
            }
        }

        public FilterSpectralHighpassForm(FilterSpectralHighpassParams pars)
        {
            InitializeComponent();

            this.pars = pars;

            this.userChanged = false;
            trackBarCutoff.Minimum = pars.CutoffRange.Min;
            trackBarCutoff.Maximum = pars.CutoffRange.Max;
            trackBarCutoff.Value = pars.Cutoff;
            trackBarCutoff.TickStyle = TickStyle.None;
            numericUpDownCutoff.Minimum = pars.CutoffRange.Min;
            numericUpDownCutoff.Maximum = pars.CutoffRange.Max;
            numericUpDownCutoff.Value = pars.Cutoff;
            this.userChanged = true;
        }

        public FilterSpectralHighpassForm()
        {
            InitializeComponent();
        }

        private void trackBarCutoff_ValueChanged(object sender, EventArgs e)
        {
            if (userChanged)
            {
                userChanged = false;
                int val = trackBarCutoff.Value;
                this.pars.Cutoff = val;
                numericUpDownCutoff.Value = Math.Min(this.pars.CutoffRange.Max, Math.Max(this.pars.CutoffRange.Min, val));
                userChanged = true;
            }
        }

        private void numericUpDownCutoff_ValueChanged(object sender, EventArgs e)
        {
            if (userChanged)
            {
                userChanged = false;
                int val = (int)numericUpDownCutoff.Value;
                this.pars.Cutoff = val;
                trackBarCutoff.Value = Math.Min(this.pars.CutoffRange.Max, Math.Max(this.pars.CutoffRange.Min, val));
                userChanged = true;
            }
        }

        private void buttonOK_Click(object sender, EventArgs e)
        {
            this.DialogResult = DialogResult.OK;
            this.Dispose();
        }

        private void buttonCancel_Click(object sender, EventArgs e)
        {
            this.DialogResult = DialogResult.Cancel;
            this.Dispose();
        }
    }
}