using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

namespace ImageSharpApp.AlgProcessor.Forms
{
    partial class GrayContrastStretchForm : Form
    {
        private bool userChanged = false;
        private GrayContrastStretchParams pars = null;

        public GrayContrastStretchParams Params
        {
            get
            {
                return this.pars;
            }
        }

        public GrayContrastStretchForm(GrayContrastStretchParams pars)
        {
            InitializeComponent();

            this.pars = pars;

            this.userChanged = false;
            trackBarLPX.Minimum = pars.GrayRange.Min;
            trackBarLPX.Maximum = pars.GrayRange.Max;
            trackBarLPX.Value = pars.GrayOld1;
            trackBarLPY.Minimum = pars.GrayRange.Min;
            trackBarLPY.Maximum = pars.GrayRange.Max;
            trackBarLPY.Value = pars.GrayNew1;
            trackBarUPX.Minimum = pars.GrayRange.Min;
            trackBarUPX.Maximum = pars.GrayRange.Max;
            trackBarUPX.Value = pars.GrayOld2;
            trackBarUPY.Minimum = pars.GrayRange.Min;
            trackBarUPY.Maximum = pars.GrayRange.Max;
            trackBarUPY.Value = pars.GrayNew2;
            trackBarLPX.TickStyle = TickStyle.None;
            trackBarLPY.TickStyle = TickStyle.None;
            trackBarUPX.TickStyle = TickStyle.None;
            trackBarUPY.TickStyle = TickStyle.None;
            numericUpDownLPX.Minimum = pars.GrayRange.Min;
            numericUpDownLPX.Maximum = pars.GrayRange.Max;
            numericUpDownLPX.Value = pars.GrayOld1;
            numericUpDownLPY.Minimum = pars.GrayRange.Min;
            numericUpDownLPY.Maximum = pars.GrayRange.Max;
            numericUpDownLPY.Value = pars.GrayNew1;
            numericUpDownUPX.Minimum = pars.GrayRange.Min;
            numericUpDownUPX.Maximum = pars.GrayRange.Max;
            numericUpDownUPX.Value = pars.GrayOld2;
            numericUpDownUPY.Minimum = pars.GrayRange.Min;
            numericUpDownUPY.Maximum = pars.GrayRange.Max;
            numericUpDownUPY.Value = pars.GrayNew2;
            this.userChanged = true;
        }

        public GrayContrastStretchForm()
        {
            InitializeComponent();
        }

        private void trackBarLPX_ValueChanged(object sender, EventArgs e)
        {
            if (userChanged)
            {
                userChanged = false;
                byte val = (byte)trackBarLPX.Value;
                this.pars.GrayOld1 = val;
                numericUpDownLPX.Value = Math.Min(this.pars.GrayRange.Max, Math.Max(this.pars.GrayRange.Min, val));
                userChanged = true;
            }
        }

        private void trackBarLPY_ValueChanged(object sender, EventArgs e)
        {
            if (userChanged)
            {
                userChanged = false;
                byte val = (byte)trackBarLPY.Value;
                this.pars.GrayNew1 = val;
                numericUpDownLPY.Value = Math.Min(this.pars.GrayRange.Max, Math.Max(this.pars.GrayRange.Min, val));
                userChanged = true;
            }
        }

        private void numericUpDownLPX_ValueChanged(object sender, EventArgs e)
        {
            if (userChanged)
            {
                userChanged = false;
                byte val = (byte)numericUpDownLPX.Value;
                this.pars.GrayOld1 = val;
                trackBarLPX.Value = Math.Min(this.pars.GrayRange.Max, Math.Max(this.pars.GrayRange.Min, val));
                userChanged = true;
            }
        }

        private void numericUpDownLPY_ValueChanged(object sender, EventArgs e)
        {
            if (userChanged)
            {
                userChanged = false;
                byte val = (byte)numericUpDownLPY.Value;
                this.pars.GrayNew1 = val;
                trackBarLPY.Value = Math.Min(this.pars.GrayRange.Max, Math.Max(this.pars.GrayRange.Min, val));
                userChanged = true;
            }
        }

        private void trackBarUPX_ValueChanged(object sender, EventArgs e)
        {
            if (userChanged)
            {
                userChanged = false;
                byte val = (byte)trackBarUPX.Value;
                this.pars.GrayOld2 = val;
                numericUpDownUPX.Value = Math.Min(this.pars.GrayRange.Max, Math.Max(this.pars.GrayRange.Min, val));
                userChanged = true;
            }
        }

        private void trackBarUPY_ValueChanged(object sender, EventArgs e)
        {
            if (userChanged)
            {
                userChanged = false;
                byte val = (byte)trackBarUPY.Value;
                this.pars.GrayNew2 = val;
                numericUpDownUPY.Value = Math.Min(this.pars.GrayRange.Max, Math.Max(this.pars.GrayRange.Min, val));
                userChanged = true;
            }
        }

        private void numericUpDownUPX_ValueChanged(object sender, EventArgs e)
        {
            if (userChanged)
            {
                userChanged = false;
                byte val = (byte)numericUpDownUPX.Value;
                this.pars.GrayOld2 = val;
                trackBarUPX.Value = Math.Min(this.pars.GrayRange.Max, Math.Max(this.pars.GrayRange.Min, val));
                userChanged = true;
            }
        }

        private void numericUpDownUPY_ValueChanged(object sender, EventArgs e)
        {
            if (userChanged)
            {
                userChanged = false;
                byte val = (byte)numericUpDownUPY.Value;
                this.pars.GrayNew2 = val;
                trackBarUPY.Value = Math.Min(this.pars.GrayRange.Max, Math.Max(this.pars.GrayRange.Min, val));
                userChanged = true;
            }
        }

        private void buttonOK_Click(object sender, EventArgs e)
        {
            this.DialogResult = DialogResult.OK;
            this.Dispose();
        }

        private void buttonCancel_Click(object sender, EventArgs e)
        {
            this.DialogResult = DialogResult.Cancel;
            this.Dispose();
        }
    }
}